/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_RENTABILIDADE                                   */
/* Tabela : RENTABILIDADE                                                     */
/*                                                                            */
/* Criao:                                                                   */
/* 29/11/2010 - William A. Paula                                                  */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_RENTABILIDADE
BEFORE INSERT OR UPDATE OR DELETE
ON RENTABILIDADE FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATU := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.NRSEQRENT,0) <> NVL(:NEW.NRSEQRENT,0)) OR
         (NVL(:OLD.VRPERCINIRENT,0) <> NVL(:NEW.VRPERCINIRENT,0)) OR
         (NVL(:OLD.VRCORRENT,0) <> NVL(:NEW.VRCORRENT,0)) OR
         (NVL(:OLD.VRPERCFIMRENT,0) <> NVL(:NEW.VRPERCFIMRENT,0)) THEN
         :NEW.DTULTATU := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('RENTABILIDADE', '', 'NRSEQRENT='||:OLD.NRSEQRENT||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE RENTABILIDADE MODIFY DTULTATU DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_RENTABILIDADE','4.11.134'); END;
/